package com.fp.persistence.parmas.fun;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMINVENTARIOSUBIDOPORPERSONA*/
@Entity(name="TarmInventarioSubidoPorPersona")
@Table(name="TARMINVENTARIOSUBIDOPORPERSONA")
public class TarmInventarioSubidoPorPersona extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmInventarioSubidoPorPersona
*/
@EmbeddedId
private TarmInventarioSubidoPorPersonaKey pk;
@Column(name="FECHACARGA", nullable=true)

/**
* null
*/
private Timestamp fechacarga;

/**Contructor por defecto*/
public TarmInventarioSubidoPorPersona(){
}
/**Contructor de TarmInventarioSubidoPorPersona
@param pPk Clave Primaria del entity
*/
public TarmInventarioSubidoPorPersona(TarmInventarioSubidoPorPersonaKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmInventarioSubidoPorPersona
*/
public static TarmInventarioSubidoPorPersona find(EntityManager pEntityManager,TarmInventarioSubidoPorPersonaKey pKey) throws Exception{
    TarmInventarioSubidoPorPersona obj = pEntityManager.find(TarmInventarioSubidoPorPersona.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmInventarioSubidoPorPersona
@return El objeto que referencia a la Clave primaria de TarmInventarioSubidoPorPersona
*/
public TarmInventarioSubidoPorPersonaKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmInventarioSubidoPorPersona
@param pPk El objeto que referencia a la nueva Clave primaria de TarmInventarioSubidoPorPersona
*/
public void setPk(TarmInventarioSubidoPorPersonaKey pPk){
  pk=pPk;
}
/**Obtiene el valor de fechacarga
@return valor de fechacarga*/
public Timestamp getFechacarga(){
  return fechacarga;
}
/**Fija el valor de fechacarga
@param pFechacarga nuevo Valor de fechacarga*/
public void setFechacarga(Timestamp pFechacarga){
  fechacarga=pFechacarga;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmInventarioSubidoPorPersona))return false;
    TarmInventarioSubidoPorPersona that = (TarmInventarioSubidoPorPersona) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmInventarioSubidoPorPersona
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmInventarioSubidoPorPersona
*/
public Object createInstance(){
 TarmInventarioSubidoPorPersona instance=new TarmInventarioSubidoPorPersona();	
 instance.setPk(new TarmInventarioSubidoPorPersonaKey());
 return instance;
}
/**Clona la entidad TarmInventarioSubidoPorPersona
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmInventarioSubidoPorPersona p=(TarmInventarioSubidoPorPersona)this.clone();
  p.setPk((TarmInventarioSubidoPorPersonaKey)this.pk.cloneMe());
  return p;
}
}
